class PanelColorsController < ApplicationController
  layout 'test' if MagicNumber['test_layout']
  if MagicNumber['run_mode'] == 0
    before_filter :authenticate_user, :only => []
  else
    before_filter :authenticate_reader, :only => [:index, :show]
    before_filter :authenticate_user, :only => []
  end

  # GET /ground_pictures
  # GET /ground_pictures.json
  def index
    @page = PanelColor.page params[:page]
    @page_size = PanelColor.page_size params[:page_size]
    @panel_colors = PanelColor.list( @page, @page_size)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render :json => @panel_colors.to_json(PanelColor.list_json_opt) }
    end
  end
  
  def show
    @panel_color = PanelColor.show(params[:id], @author)
    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @panel_color.to_json(PanelColor.show_json_opt) }
    end
  end

end
