class ProviderStatus < ActiveRecord::Base
  has_one :provider
  
#  validates :token
  validates :receive_hour1, :numericality => {:allow_blank => true}
  validates :receive_hour2, :numericality => {:allow_blank => true}
#  validates :received_at
#  validates :stopped_at
  
  def supply_default
  end
  
  def overwrite
  end
  
  def own? ad
    return false unless ad
    ad.is_a?(Admin)
  end
  
  def visible? ad
    return false unless ad
    ad.is_a?(Admin)
  end
  
  def status
    self.token.blank? ? 0 : 1
  end
  
  def self.default_page_size
    25
  end
  
  def self.max_page_size
    100
  end
  
  def self.default_panel_size
    30
  end
  
  def self.max_panel_size
    200
  end
  
  def self.page prm = nil
    page = prm.to_i
    page = 1 if page < 1
    page
  end
  
  def self.page_size prm = self.default_page_size
    page_size = prm.to_i
    page_size = self.max_page_size if page_size > self.max_page_size
    page_size = self.default_page_size if page_size < 1
    page_size
  end
  
  def self.list page = 1, page_size = self.default_page_size
    opt = {}
    opt.merge!(ProviderStatus.list_opt)
    opt.merge!({:limit => page_size, :offset => (page -1) * page_size}) if page_size > 0
    opt.merge!({:order => 'providers.name'})
    ProviderStatus.find(:all, opt)
  end
  
  def self.available_list page = 1, page_size = self.default_page_size
    opt = {}
    opt.merge!(ProviderStatus.list_opt)
    opt.merge!({:limit => page_size, :offset => (page -1) * page_size}) if page_size > 0
    opt.merge!({:conditions => ['provider_statuses.token is null'], :order => 'providers.name'})
    ProviderStatus.find(:all, opt)
  end
  
  def self.list_opt
    {:include => {:provider => {}} }
  end
  
  def self.list_json_opt
    {:include => {:provider => {}} }
  end
  
  def self.show pid, ad
    opt = {}
    opt.merge!(ProviderStatus.show_opt)
    res = ProviderStatus.find(pid, opt)
    raise ActiveRecord::Forbidden unless res.visible?(ad)
    res
  end
  
  def self.edit pid, ad
    opt = {}
    opt.merge!(ProviderStatus.show_opt)
    res = ProviderStatus.find(pid, opt)
    raise ActiveRecord::Forbidden unless res.own?(ad)
    res
  end
  
  def self.show_opt
    {:include => {:provider => {}} }
  end
  
  def self.show_json_opt
    {:include => {:provider => {}} }
  end
  
  def stop
    self.token = nil
    self.save
  end
  
end
